<template>
    <a class="text-white" @click="mostrarModalEditarMuro" href="#" v-if="user.id==muro.usuario.id">
        Editar muro
    </a>
<!--modal -->
    <div id="modalEditarMuro">
        <div class="container-fluid h-100" id="modalEditarMuro-container">
            <div id="modalEditarMuro-botonCerrar" @click="ocultarModalEditarMuro">X</div>
            
                <input name="id_foto_portada" type="number" style="display:none" :value="id_foto_portada">
                <input name="id_foto_perfil" type="number" style="display:none" :value="id_foto_perfil">
                <div class="row p-5 pt-0">
                    <div class="col-12 text-center text-white">
                        <legend>Editar muro</legend>
                    </div>
                    <div class="col-12" id="contenedor-FotoPortadaYPerfil">
                        <div id="contenedor-imagen-portada-editar" v-if="publicacionPortada">
                            <img id="foto-portada-editar" class="h-100 w-100" :src="publicacionPortada.imagen" alt="">
                            <div class="bg-white p-1" id="contenedor-imagen-perfil-editar" v-if="publicacionPerfil">
                                <img :src="publicacionPerfil.imagen" id="foto-perfil-editar" alt="">
                            </div>
                        </div>
                    </div>
                    <div class="col-12 mt-5">
                        <div class="row">
                            <div class="col-4  mb-3" >
                                <div class="form-floating">
                                <input v-model="formulario.lugarNacimiento" type="text" class="form-control" id="floatingNacimiento" placeholder="Lugar de nacimiento">
                                <label for="floatingNacimiento">Lugar de nacimiento</label>
                                </div>
                            </div>
                            <div class="col-4 d-flex align-items-center justify-content-center mb-3">
                                <div class="dropdown" v-if="publicaciones">
                                    <button class="btn btn-secondary btn-lg dropdown-toggle" type="button" data-bs-toggle="dropdown" aria-expanded="false" @click="clickCambiarPerfil">
                                        Seleccionar foto de perfil
                                    </button>
                                    <div class="dropdown-menu row p-holder">
                                        <div class="dropdown-item col-12" v-for="publicacion in publicaciones" :key="publicacion">
                                            <div class="row" @click="cambiar(publicacion)" v-if="publicacion.imagen">
                                                <div class="col-6">
                                                    <img class="mini-img" :src="publicacion.imagen" alt="">
                                                </div>
                                                <div class="col-6 texto-mini">
                                                    {{ publicacion.textoDeLaImagen }}
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-4 d-flex align-items-center justify-content-center mb-3">
                                <div class="dropdown" v-if="publicaciones">
                                    <button class="btn btn-lg btn-secondary dropdown-toggle" type="button" data-bs-toggle="dropdown" aria-expanded="false" @click="clickCambiarPortada">
                                        Seleccionar foto de portada 
                                    </button>
                                    <div class="dropdown-menu row p-holder">
                                        <div class="dropdown-item col-12" v-for="publicacion in publicaciones" :key="publicacion">
                                            <div class="row" @click="cambiar(publicacion)" v-if="publicacion.imagen">
                                                <div class="col-6">
                                                    <img class="mini-img" :src="publicacion.imagen" alt="">
                                                </div>
                                                <div class="col-6 texto-mini">
                                                    {{ publicacion.textoDeLaImagen }}
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-12">
                        <div class="form-floating">
                            <textarea v-model="formulario.descripcion" type="text" class="form-control" id="desc" placeholder="Biografia" rows="30" style="height:18vh"></textarea>
                            <label for="desc">Biografia</label>
                        </div>
                    </div>
                    <div class="col-12 d-flex justify-content-center">
                        <button class="btn btn-primary mt-4" @click="enviar">Actualizar</button>
                    </div>
                </div>
            
        </div>
    </div>
</template>

<script>
import axios from 'axios';
import {buscarImagenPubli} from "@/Services/muro/MuroService.js"
export default {
    name: "EditarMuro",
    data(){
        return{
            publicacionPerfil:null,
            publicacionPortada:null,
            formulario:{
                idFotoPerfil:null,
                idFotoPortada:null,
                lugarNacimiento:null,
                descripcion:null
            },
            publicaciones:[]
        }
    },
    props:{
        muro:{
        },
        publicacionPerfilActual:{},
        publicacionPortadaActual:{},
        publicacionesEntrada:[],
        user:{}
    },
    methods:{
        mostrarModalEditarMuro(){
            let modal = document.getElementById("modalEditarMuro");
            let contenido=document.getElementById("modalEditarMuro-container");
            modal.style.display = "block";

            setTimeout(() => {
                modal.style.background = "rgba(0, 0, 0, 0.9)";
                contenido.style.opacity="100%";
                modal.style.setProperty("backdrop-filter", "blur(10px)");
            }, 0);
        },
        ocultarModalEditarMuro(){
            let modal=document.getElementById("modalEditarMuro");
            let contenido=document.getElementById("modalEditarMuro-container");
            modal.style.setProperty("backdrop-filter", "blur(0px)");
            modal.style.background = "rgba(0, 0, 0, 0)";
            contenido.style.opacity="0";

            setTimeout(()=>{
                modal.style.display="none";
            },200)
        },
        clickCambiarPerfil(){
            this.cambiarImg="PERFIL"
            console.log(this.publicaciones)
        },
        clickCambiarPortada(){
            this.cambiarImg="PORTADA"
        },
        cambiar(publicacion){
            if(this.cambiarImg=="PERFIL"){
                this.publicacionPerfil=publicacion;
                this.formulario.idFotoPerfil=publicacion.id;
            }else{
                this.publicacionPortada=publicacion;
                this.formulario.idFotoPortada=publicacion.id;
            }
        },
        async enviar(){
            console.log(this.formulario);
            try{
                await axios.put("http://localhost:3001/muro/editar",null,{params:{
                id_foto_portada: this.formulario.idFotoPortada,
                id_foto_perfil: this.formulario.idFotoPerfil,
                descripcion: this.formulario.descripcion,
                lugar_de_nacimiento: this.formulario.lugarNacimiento
              }
              })
              location.reload();
            }catch(e){
                console.log(e)
            }
        },
        async cargarImgs(){
            try {
                const array=[];
                for (let i = 0; i < this.publicacionesEntrada.length; i++) {
                    const element =this.publicacionesEntrada[i];

                    const data= await buscarImagenPubli(element.imagenes[0]);
                    element.imagen=data;
                    array.push(element);
                    
                }
                return array;
            } catch (error) {
                console.log(error);
            }
        }
    },
    async mounted(){
        this.publicacionPerfil=this.publicacionPerfilActual;
        this.publicacionPortada=this.publicacionPortadaActual;
        this.publicaciones= await this.cargarImgs();
    }
}
</script>

<style scoped>
.texto-mini{
    width: 100px;
    overflow: auto;
}
.p-holder{
    height: 50vh;
    overflow: hidden scroll;
}
.mini-img{
    object-fit: cover;
    height: 100px;
    width: 100%;
}
#contenedor-FotoPortadaYPerfil{
    margin-bottom: 30px;
}
#contenedor-imagen-portada-editar{
    height: 40vh;
    position: relative;
    margin-bottom: 80px;
}
#contenedor-imagen-perfil-editar{
    position: absolute;
    bottom: -35%;
    left: 30px;
    border-radius: 50%;
}
#foto-perfil-editar{
    border-radius: 50%;
    height: 240px;
    width: 240px;
    object-fit: cover;
}
#foto-portada-editar{
    object-fit: cover;
}
/* Modal */
#modalEditarMuro{
    display: none;
    position: fixed;
    transition: background-color .2s;
    height: 100vh;
    width: 100%;
    top:0;
    left:0;
    z-index: 100;
}
#modalEditarMuro-container{
    opacity: 0;
    transition: opacity .2s;
}
#modalEditarMuro-botonCerrar{
    color: white;
    position: fixed;
    margin: 10px;
    width: 50px;
    height: 50px;
    top: 0;
    right: 0;
    z-index: 200;
    cursor: pointer;
}
</style>